#include <stdio.h>
#include <string.h>
#include "main.h"
#include <unistd.h>
#include "serial.h"

int
vax_init (int fd)
{
	unsigned char one_byte;
	int ret;

	serial_send_break (fd, 0);
	do {
		ret = serial_read_byte (fd, &one_byte, 1, 0);
	} while (ret == 0);
	sleep (3);
	do {
		ret = serial_read_byte (fd, &one_byte, 1, 0);
	} while (ret == 0);

	return 0;
}

int
vax_get_byte (int fd, unsigned char *output, unsigned long long int address)
{
	unsigned char output_buffer[100];
	unsigned char input_buffer[200];
	unsigned char *ptr;
	int ret;
	int input_len = 0;

	sprintf (output_buffer, "EXAMINE /B /P /U %08lx\r\n", (unsigned long) address);
	serial_write (fd, output_buffer, strlen (output_buffer));

	bzero (input_buffer, sizeof (input_buffer));
	do {
		ret = serial_read_byte (fd, &input_buffer[input_len], 1, 0);
		if (ret == 0)
			input_len++;
	} while (ret == 0 && input_len < sizeof (input_buffer) && !strstr (input_buffer, ">>> "));

	if (ret)
		return -1;

	ptr = input_buffer;
	/* Over-read first line */
	while (*ptr != '\n' && *ptr != '\r')
		ptr++;
	while (*ptr == '\n' || *ptr == '\r')
		ptr++;
	ptr++;

	/* Strip leading spaces of second line */
	while (*ptr == ' ')
		ptr++;

	/* Over-read 'P' */
	ptr++;

	/* Strip leading spaces of second line */
	while (*ptr == ' ')
		ptr++;

	/* Strip address */
	while (			((*ptr >= '0') && (*ptr <= '9'))
			||	((*ptr >= 'a') && (*ptr <= 'z'))
			||	((*ptr >= 'A') && (*ptr <= 'Z')))
		*ptr++;

	/* Strip leading spaces */
	while (*ptr == ' ')
		ptr++;

	/* Now get the byte */
	if (*ptr >= 'A' && *ptr <= 'Z')
		*ptr = *ptr - 'A' + 'a';
	if (*ptr >= '0' && *ptr <= '9')
		*output = *ptr - '0';
	else
		*output = *ptr - 'a' + 10;

	*output <<= 4;
	ptr++;

	if (*ptr >= 'A' && *ptr <= 'Z')
		*ptr = *ptr - 'A' + 'a';
	if (*ptr >= '0' && *ptr <= '9')
		*output |= *ptr - '0';
	else
		*output |= *ptr - 'a' + 10;

	return 0;
}

