#ifndef _SERIAL_H
#define _SERIAL_H

#include <sys/types.h>
#include <sys/ioctl.h>

#define SER_STX	0x02
#define SER_ETX	0x03
#define SER_EOT	0x04
#define SER_ENQ 0x05
#define SER_ACK	0x06
#define SER_DLE	0x10
#define SER_NAK	0x15
#define SER_ETB	0x17
#define SER_RS	0x1e

extern int	serial_open (unsigned char *device);
extern int	serial_open_luxury (unsigned char *device, unsigned int speed,
				unsigned char bits, unsigned char parity,
				unsigned char stop);
extern int	serial_close (int fd);
extern int	serial_set_speed (int fd, unsigned int speed);
extern int	serial_set_bits (int fd, unsigned char bits);
extern int	serial_set_parity (int fd, unsigned char parity);
extern int	serial_set_stop (int fd, unsigned char stop);
extern int	serial_set_one_byte_each (int fd);
extern int	serial_write_byte (int fd, unsigned char byte);
extern int	serial_write_byte_rb (int fd, unsigned char byte); /* with readback */
extern size_t	serial_write (int fd, unsigned char *buf, size_t len); /* returning remaining byte # not sent */
extern size_t	serial_write_rb (int fd, unsigned char *buf, size_t len); /* returning remaining byte # not sent, with readback */
extern int	serial_read_byte (int fd, unsigned char *byte, time_t sec,
				suseconds_t usec);
extern int	serial_get_modem (int fd, int what, int *result);
extern int	serial_set_modem (int fd, int what, int state);
extern int	serial_send_break (int fd, int duration);

#endif /* _SERIAL_H */
